<template>
    <div>
        <div>
            <Button class="btnChose" type="success" @click="showStartPick=true" >Chọn nơi đi</Button>
            <small>{{startLoc.lat()}} -  {{startLoc.lng()}}</small>
            <p></p>
            <pick-location key="start" v-if="showStartPick" v-model="startLoc" @close="handleStartPickClose()"></pick-location>
            <Button class="btnChose" type="success" @click="showEndPick=true" >Chọn nơi đến</Button>
            <small>{{endLoc.lat()}} -  {{endLoc.lng()}}</small>
            <pick-location key="end" v-if="showEndPick" v-model="endLoc" @close="handleEndPickClose()"></pick-location>
            <p></p>
    
            <Button class="btnAction" type="success" @click="findway()" :loading="loading" >Tìm đường</Button>
            <Button  class="btnAction" type="error" @click="clearDraw()">Xóa</Button>
        </div>
        <div id="instructor" :style="{height:heightInstructor+'px'}">
            <b>Hướng dẫn đi tới điểm dừng</b>
            <div id="display-start"></div>
            <b>Hướng dẫn đi từ điểm dừng tới nơi đến</b>
            <div id="display-end"></div>
        </div>
    </div>
</template>
<script>
    import PickLocation from '@/components/PickLocation.vue'
    import { distanceCalc } from '@/Utils/distanceCalc'
    import { drawRouter } from '@/Utils/drawRouter'
    import {drawGMRouterCustom} from '@/Utils/drawGMRouterCustom'
    export default {
        data() {
            return {
                startLoc: { lat() { return 0 }, lng() { return 0 } },
                showStartPick: false,
                endLoc: { lat() { return 0 }, lng() { return 0 } },
                showEndPick: false,
                markBegin: {},
                markEnd: {},
                loading: false,
                polyLineStart:{},
                polyLineEnd:{},
                directionsDisplay:{},
                heightInstructor: window.innerHeight - (168 + 37 + 50)
            }
        },
        components: {
            PickLocation
        },
        mounted() {

        },
        computed: {
            listBusStop: function() {
                let listRouters = this.$store.state.listRouters;
                let listBusStop = [];
                let listBusStopKey = [];
                listRouters.forEach(e => e.wayPoints.forEach(wayPoint => {
                    if (wayPoint.busStop) {
                        let wayPointKey = String(wayPoint.x) + wayPoint.y;
                        if (listBusStopKey.indexOf(wayPointKey) == -1) {
                            listBusStopKey.push(wayPointKey);
                            let wayPointGM = new window.google.maps.LatLng(wayPoint.x, wayPoint.y);
                            listBusStop.push(wayPointGM);
                        }
                    }

                }))
                return listBusStop;
            }
        },
        methods: {
            handleStartPickClose: function() {
                this.showStartPick = false;
                if (this.markBegin.setMap != undefined) { this.markBegin.setMap(null) }
                this.markBegin = new window.google.maps.Marker({
                    map: this.$store.state.map,
                    position: this.startLoc,
                    icon: '/noidi.png',
                    // draggable: true,
                    animation: window.google.maps.Animation.DROP
                });
            },
            handleEndPickClose: function() {
                this.showEndPick = false;
                if (this.markEnd.setMap != undefined) { this.markEnd.setMap(null) }
                this.markEnd = new window.google.maps.Marker({
                    map: this.$store.state.map,
                    position: this.endLoc,
                    icon: '/noiden.png',
                    // draggable: true,
                    animation: window.google.maps.Animation.DROP
                });
            },
            clearDraw: function() {
                if (this.markBegin.setMap != undefined) { this.markBegin.setMap(null) }
                if (this.markEnd.setMap != undefined) { this.markEnd.setMap(null) }
                this.startLoc = { lat() { return 0 }, lng() { return 0 } };
                this.endLoc = { lat() { return 0 }, lng() { return 0 } };
                this.directionsDisplay.setDirections({ routes: [] });
                this.polyLineStart.setPath([]);
                this.polyLineEnd.setPath([]);
            },
            findway: async function() {
                try {
                    this.loading = true;
                    let { routerNameWillGo, busStopPickUp, busStopGetOff } = await this.shortestPath(this.startLoc, this.endLoc);
                    this.polyLineStart=await drawGMRouterCustom(this.startLoc,busStopPickUp,this.$store.state.map,this.polyLineStart, "WALKING", "display-start");
                    this.polyLineEnd=await  drawGMRouterCustom(busStopGetOff,this.endLoc,this.$store.state.map,this.polyLineEnd, "WALKING", "display-end");
                    this.directionsDisplay=await drawRouter(routerNameWillGo,this.$store.state.listRouters,this.$store.state.map,this.directionsDisplay,"displayRouter");
                    this.$store.state.map.setCenter(this.startLoc);
                    setTimeout(this.$store.state.map.setZoom(16),1000);
                    this.loading = false;
                }
                catch (e) {
                    console.log("Findway error: ");
                    console.log(e);
                    this.loading = true;

                }
            },
            shortestPath: async function(_start, _end) {
                let routerWillGo = []
                let busStopPickUp = {}
                let busStopGetOff = {}
                let listBus = []
                let listRouters = this.$store.state.listRouters;
                let minTotalDistance = 1000000000;
                let routerNameWillGo = "";
                for (let x = 0; x < listRouters.length; x++) {
                    let router = listRouters[x];
                    let waypointGM = new window.google.maps.LatLng(String(router.wayPoints[0].x), String(router.wayPoints[0].y));
                    let _nearestStartBusStopInRouter = waypointGM;
                    let _nearestEndBusStopInRouter = waypointGM;
                    let minDistanceFromStart = await distanceCalc(_start, waypointGM, [], "WALKING")
                    let minDistanceFromEnd = await distanceCalc(_end, waypointGM, [], "WALKING")
                    console.log(`Router thu ${x}: ${router.name}, khoang cach ngan nhat den diem dau ${minDistanceFromStart}, diem cuoi ${minDistanceFromEnd}`)
                    let indexBusStopStart = 0;
                    let indexBusStopEnd = 0;
                    for (let i = 1; i < router.wayPoints.length; i++) {
                        let wayPoint = router.wayPoints[i]
                        waypointGM = new window.google.maps.LatLng(String(wayPoint.x), String(wayPoint.y));
                        if (wayPoint.busStop) {
                            let distanceFromStart = await distanceCalc(_start, waypointGM, [], "WALKING");
                            if (distanceFromStart < minDistanceFromStart) {
                                minDistanceFromStart = distanceFromStart;
                                _nearestStartBusStopInRouter = waypointGM;
                                indexBusStopStart = i;
                            }
                            let distanceFromEnd = await distanceCalc(_end, waypointGM, [], "WALKING");
                            if (distanceFromEnd < minDistanceFromEnd) {
                                minDistanceFromEnd = distanceFromEnd;
                                _nearestEndBusStopInRouter = waypointGM;
                                indexBusStopEnd = i;
                            }
                            console.log(`Router thu ${x}: ${router.name}, diem dung ${i}, khoang cach ${distanceFromStart}, ${distanceFromEnd}`)
                        }
                    }
                    if (indexBusStopStart > indexBusStopEnd) {
                        let temp = indexBusStopStart;
                        indexBusStopStart = indexBusStopEnd;
                        indexBusStopEnd = temp;
                    }
                    let partOfRouter = router.wayPoints.slice(indexBusStopStart, indexBusStopEnd);
                    let waypts = [];
                    for (let i = 1; i < partOfRouter.length - 1; i++) {
                        let e = partOfRouter[i];
                        let waypt = {
                            location: new window.google.maps.LatLng(e.x, e.y),
                            stopover: e.busStop ? true : false
                        }
                        waypts.push(waypt);
                    }
                    console.log(`==> KQ: Router thu ${x}: ${router.name}, diem dung ${indexBusStopStart}, khoang cach ${minDistanceFromStart}, diem dung ${indexBusStopEnd}, khoang cach ${minDistanceFromEnd}`)
                    let distanceOfPartRouter = await distanceCalc(_nearestStartBusStopInRouter, _nearestEndBusStopInRouter, waypts)
                    let totalDistance = minDistanceFromStart + distanceOfPartRouter + minDistanceFromEnd;
                    if (totalDistance < minTotalDistance) {
                        minTotalDistance = totalDistance;
                        routerWillGo = partOfRouter;
                        busStopPickUp = _nearestStartBusStopInRouter;
                        busStopGetOff = _nearestEndBusStopInRouter;
                        routerNameWillGo = router.name;
                    }
                }
                return { routerNameWillGo, routerWillGo, busStopPickUp, busStopGetOff, listBus }
            },
        }
    }
</script>
<style type="text/css">
    #button-search {
        display: block;
        margin: 10px auto;
    }

    .btnChose {
        width: 100px;
        margin: 10px;
    }

    .btnAction {
        width: 90%;
        margin: 5px 5%;
    }

    #instructor {
        overflow-y: scroll;
    }
</style>
